var SboxTable = new Array();
SboxTable[ 0] = new Array(0xd6,0x90,0xe9,0xfe,0xcc,0xe1,0x3d,0xb7,0x16,0xb6,0x14,0xc2,0x28,0xfb,0x2c,0x05);
SboxTable[ 1] = new Array(0x2b,0x67,0x9a,0x76,0x2a,0xbe,0x04,0xc3,0xaa,0x44,0x13,0x26,0x49,0x86,0x06,0x99);
SboxTable[ 2] = new Array(0x9c,0x42,0x50,0xf4,0x91,0xef,0x98,0x7a,0x33,0x54,0x0b,0x43,0xed,0xcf,0xac,0x62);
SboxTable[ 3] = new Array(0xe4,0xb3,0x1c,0xa9,0xc9,0x08,0xe8,0x95,0x80,0xdf,0x94,0xfa,0x75,0x8f,0x3f,0xa6);
SboxTable[ 4] = new Array(0x47,0x07,0xa7,0xfc,0xf3,0x73,0x17,0xba,0x83,0x59,0x3c,0x19,0xe6,0x85,0x4f,0xa8);
SboxTable[ 5] = new Array(0x68,0x6b,0x81,0xb2,0x71,0x64,0xda,0x8b,0xf8,0xeb,0x0f,0x4b,0x70,0x56,0x9d,0x35);
SboxTable[ 6] = new Array(0x1e,0x24,0x0e,0x5e,0x63,0x58,0xd1,0xa2,0x25,0x22,0x7c,0x3b,0x01,0x21,0x78,0x87);
SboxTable[ 7] = new Array(0xd4,0x00,0x46,0x57,0x9f,0xd3,0x27,0x52,0x4c,0x36,0x02,0xe7,0xa0,0xc4,0xc8,0x9e);
SboxTable[ 8] = new Array(0xea,0xbf,0x8a,0xd2,0x40,0xc7,0x38,0xb5,0xa3,0xf7,0xf2,0xce,0xf9,0x61,0x15,0xa1);
SboxTable[ 9] = new Array(0xe0,0xae,0x5d,0xa4,0x9b,0x34,0x1a,0x55,0xad,0x93,0x32,0x30,0xf5,0x8c,0xb1,0xe3);
SboxTable[10] = new Array(0x1d,0xf6,0xe2,0x2e,0x82,0x66,0xca,0x60,0xc0,0x29,0x23,0xab,0x0d,0x53,0x4e,0x6f);
SboxTable[11] = new Array(0xd5,0xdb,0x37,0x45,0xde,0xfd,0x8e,0x2f,0x03,0xff,0x6a,0x72,0x6d,0x6c,0x5b,0x51);
SboxTable[12] = new Array(0x8d,0x1b,0xaf,0x92,0xbb,0xdd,0xbc,0x7f,0x11,0xd9,0x5c,0x41,0x1f,0x10,0x5a,0xd8);
SboxTable[13] = new Array(0x0a,0xc1,0x31,0x88,0xa5,0xcd,0x7b,0xbd,0x2d,0x74,0xd0,0x12,0xb8,0xe5,0xb4,0xb0);
SboxTable[14] = new Array(0x89,0x69,0x97,0x4a,0x0c,0x96,0x77,0x7e,0x65,0xb9,0xf1,0x09,0xc5,0x6e,0xc6,0x84);
SboxTable[15] = new Array(0x18,0xf0,0x7d,0xec,0x3a,0xdc,0x4d,0x20,0x79,0xee,0x5f,0x3e,0xd7,0xcb,0x39,0x48);

var CK = new Array(
    0x00070e15,0x1c232a31,0x383f464d,0x545b6269,
    0x70777e85,0x8c939aa1,0xa8afb6bd,0xc4cbd2d9,
    0xe0e7eef5,0xfc030a11,0x181f262d,0x343b4249,
    0x50575e65,0x6c737a81,0x888f969d,0xa4abb2b9,
    0xc0c7ced5,0xdce3eaf1,0xf8ff060d,0x141b2229,
    0x30373e45,0x4c535a61,0x686f767d,0x848b9299,
    0xa0a7aeb5,0xbcc3cad1,0xd8dfe6ed,0xf4fb0209,
    0x10171e25,0x2c333a41,0x484f565d,0x646b7279
);

var FK = new Array(0xa3b1bac6,0x56aa3350,0x677d9197,0xb27022dc);
function sm4(){};

function bigxor(a, b){
    return a ^ b;
};

function leftshift(a, n, size) {
	size=32
	n = n % size
	return (a << n) | (a >>> (size - n))
};

function prefixInteger(str, length) {
  return Array(length+1).join("0").split("").concat(String(str).split(""))
           .slice(-length).join("");
};

function sm4Sbox(a) {
	var b1 = SboxTable[(a & 0xf0000000) >>> 28][(a & 0x0f000000) >>> 24]
	var b2 = SboxTable[(a & 0x00f00000) >>> 20][(a & 0x000f0000) >>> 16]
	var b3 = SboxTable[(a & 0x0000f000) >>> 12][(a & 0x00000f00) >>>  8]
	var b4 = SboxTable[(a & 0x000000f0) >>>  4][(a & 0x0000000f) >>>  0]
	return (b1 << 24) | (b2 << 16) | (b3 << 8) | (b4 << 0)
};

function  GET_ULONG_BE(a) {
	a = sm4Sbox(a)
	return bigxor(bigxor(bigxor(a, leftshift(a, 2)), bigxor(leftshift(a, 10), leftshift(a, 18))),leftshift(a, 24))
};

function PUT_ULONG_BE(b) {
	b = sm4Sbox(b)
	return bigxor(b, bigxor(leftshift(b, 13),leftshift(b, 23)));
};

function  sm4_getkey(MK) {
	var  K = new Array();
	var rk = new Array();
	K[0] = bigxor(MK[0], FK[0]);
	K[1] = bigxor(MK[1], FK[1]);
	K[2] = bigxor(MK[2], FK[2]);
	K[3] = bigxor(MK[3], FK[3]);
	for (var i = 0; i < 32; i++) {
		K[i+4] = bigxor(K[i], PUT_ULONG_BE(bigxor(bigxor(K[i+1], K[i+2]), bigxor(K[i+3], CK[i]))));
		rk[i] = K[i+4].toString(16);
	}
	return rk;
};

function  KJUR_encrypt_sm4(messsage, key, method) {
	var MK = key;
	var X = messsage;
	var rk =sm4_getkey(MK);
	for (var i = 0; i < 32; i++) {
		X[i+4] = bigxor(X[i], GET_ULONG_BE(bigxor(bigxor(X[i+1], X[i+2]), bigxor(X[i+3], parseInt(rk[i], 16)))))
	};
	var Y = new Array(X[35], X[34], X[33], X[32])
	return Y;
};

function  KJUR_decrypt_sm4(ciphertext, key, method) {
	var MK = key;
	var X = ciphertext;
	var frk = sm4_getkey(MK);
	var rk = new Array()
	for (var i = frk.length - 1; i >= 0; i--) {
		rk[frk.length - 1 - i] = frk[i]
	};
	for (var i = 0; i < 32; i++) {
		X[i+4] = bigxor(X[i], GET_ULONG_BE(bigxor(bigxor(X[i+1], X[i+2]),bigxor(X[i+3], parseInt(rk[i], 16)))))
	};
	var Y = new Array(X[35], X[34], X[33], X[32])
	return Y;
};

function encode(s) {
    return s.replace(/[\d\D]/g, function($) {
        return ("000" + $.charCodeAt(0).toString(16)).slice(-4);
    });
};

function decode(s) {
    return s.replace(/.{4}/g, function($) {
        return String.fromCharCode(parseInt($, 16));
    });
};

function PKCS7_padding_encode(data,back){
    var result = new Array();
    for (var i = 0; i < data.length; i++) {
        result.push(data.charCodeAt(i))
    };
    var size = 4-result.length%4;
    for (i = 0; i < size; i++) {
        result.push(size)
    }
    back(result);
};

function PKCS7_padding_decode(data){
    var result="";
    var size = data[data.length-1];

    for (var i = 0; i < size ; i++) {
        data.pop();

    };
    for(i = 0;i < data.length; i++) {
        result += String.fromCharCode(data[i]);
    };

    return result;
};

function randomkey(key) {
    var result = "";
    for(var i = 0;i < key.length/2 ;i+=8 ) {
        tempnum = bigxor(parseInt(key.slice(i,i+8), 16), Math.round(Math.random()*1000000000)).toString(16);
        result += tempnum.length == 8 ? tempnum : repeat("0",8 - tempnum.length) + tempnum ;
    }
    return result;
};

function xorkey(key,callback) {
    var result = new Array();
    for(var i = 0;i < key.length ;i+=8 ) {
        result.push(parseInt(key.slice(i,i+8), 16))
    }
    callback(result);
};

 function repeat(src,n){
	return (new Array(n + 1)).join(src);
};

function sm4_encode_cbc(data, key,callback) {
    var iv = new Array(0x01234567,0x89abcdef,0xfedcba98,0x76543210);
    var message = new Array();
    var result = new Array();
    var res = '';
    var hextext = '';

    xorkey(key,function (back) {
        PKCS7_padding_encode(data,function (backresult) {
            for (var x = 0 ; x < data.length/4 ; x++) {
                for (var i = 0 ; i < iv.length ; i++) {
                    message.push(bigxor(iv[i], backresult[i+x*4]));
                }
                ciphertext = KJUR_encrypt_sm4(message, back, "cbc");

                iv = ciphertext;
                result = result.concat(ciphertext);
                message = new Array();

            }
            for(var i=0;i<result.length;i++){
                hextext = result[i].toString(16);
                res += hextext.length == 16 ? hextext :repeat('0',8-hextext.length)+hextext;
            }

            callback(res);

        });

    });

};

function bigxor(a, b) {
    var abin = a.toString(2);
    var bbin = b.toString(2);
    var loggest = abin.length >= bbin.length ? abin.length : bbin.length;
    abin = abin.length == loggest ? abin :repeat("0",loggest - abin.length) + abin;
    bbin = bbin.length == loggest ? bbin :repeat("0",loggest - bbin.length) + bbin;
    var result = "";
    for (var i = loggest - 1; i >= 0; i--) {
        result = abin.substr(i,1) == bbin.substr(i,1) ? '0'+result : '1'+result; 
    }
    return parseInt(result, 2);
};

function sm4_decode_cbc(text, key,callback) {

	var data = new Array();
	for(var i=0;i<text.length;i+=8){
        data.push(parseInt(text.slice(i,i+8),16))
    }

    var iv = new Array(0x01234567,0x89abcdef,0xfedcba98,0x76543210);
    var message = new Array();
    var result = new Array();
    xorkey(key,function (back) {
        for(var x=data.length/4-1;x>=0;x--){
            if(x==0){
                iv = new Array(0x01234567,0x89abcdef,0xfedcba98,0x76543210);
            }else{
                iv = data.slice((x-1)*4,x*4)
            }
            message = KJUR_decrypt_sm4(data.slice(x*4,(x+1)*4), back);
            for(var j=message.length-1;j>=0;j--){
                result.push(bigxor(message[j], iv[j]))
            }
        }

        result.reverse();
        result = PKCS7_padding_decode(result);

        callback(result);
    });


};
